{% extends 'core.html' %}

{% block title %}Usuario{% endblock %}

{% load crispy_forms_tags %}

{% block staticload %}
{% load static %}
<link rel="stylesheet" href="{% static 'users/css/gradeSlider.css' %}">
{% endblock %}

{% block content %}
<div class="card container mt-5 mb-5">
    {% if error_message %}
        <div class="alert alert-warning alert-dismissible fade show mt-2" role="alert">
        <strong>Error: </strong>{{error_message}}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
        </div>    
    {% endif %}
    <div class="container mt-5 mb-2">
        <div class="row">
            <div class="col-12 col-sm-12 col-md-4 col-lg-2 col-xl-2">
                {% if user.profile_picture%}
                <img class="img-thumbnail" src="{{user.profile_picture.url}}">
                {% else %}
                <img class="img-thumbnail" src="{% static 'users/img/profile-placeholder.gif' %}">
                {% endif %}
            </div>
            <div class="col-12 col-sm-12 col-md-10 col-lg-10 col-xl-10">
                <div class="row">
                    <div class="col-12 col-sm-8 col-md-10 col-lg-10 col-xl-10">
                        <h1 class="display-4">{{ user.first_name }} {{ user.last_name }}</h1>
                    </div>
                    <div class="col-12 col-sm-4 col-md-2 col-lg-2 col-xl-2">
                        <button type="button" class="btn btn-warning" data-toggle="modal" data-target="#gradeModal">
                            <span style="font-size: 1.5em; color: #343a40;">
                                <i class="fa fa-star" aria-hidden="true"></i>
                            </span>
                            <span class="lead">{{ rate }}</span>
                        </button>
                    </div>
                    <div class="col-12 col-sm-8 col-md-10 col-lg-10 col-xl-10">
                        <h1 class="display-6">{{ user.username }}</h1>
                    </div>
                    <div class="col-12 col-sm-4 col-md-2 col-lg-2 col-xl-2">
                        <button type="button" class="btn btn-outline-danger" data-toggle="modal" data-target="#reportModal">Reportar</button>
                    </div>                    
                    <div class="col-12 col-sm-8 col-md-10 col-lg-10 col-xl-10">
                        <p class="lead">Miembro desde: {{ user.date_joined.date }}</p>
                    </div>
                    <div class="col-12 col-sm-4 col-md-2 col-lg-2 col-xl-2">
                        <button type="button" class="btn btn-outline-warning" data-toggle="modal" data-target="#suggestionModal">Sugerir</button>
                    </div>                    
                </div>
            </div>
        </div>
    </div>

    <div class="container">
        <hr />
    </div>

    <div class="container mt-2">
        <h1 class="display-5">Información Personal</h1>
        <div class="row">
            <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
                <p class="lead"><strong>Correo:</strong> {{ user.email }}</P>
            </div>
            <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
                <p class="lead"><strong>Teléfono:</strong> {{ user.mobile_phone }}</P>
            </div>
            <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
                <p class="lead"><strong>Sexo:</strong> {{ user.get_sex_display }}</P>
            </div>
            <div class="col-12 col-sm-12 col-md-6 col-lg-6 col-xl-6">
                <p class="lead"><strong>Fecha de Nacimiento:</strong> {{ user.birth_date }}</P>
            </div>
        </div>
    </div>

    <div class="container">
        <hr />
    </div>

    <div class="container mt-2">
        <h1 class="display-5">Publicaciones</h1>
        {% if publications %}
        {% for publication in publications %}
        <div class="row">
            <div class="col-12 col-sm-12 col-md-2 col-lg-2 col-xl-2">
                <a href="{{publication.get_absolute_url}}"><img class="img-thumbnail img-responsive" style="max-height:200px" src="{{publication.photo.url}}" /></a>
            </div>
            <div class="col-12 col-sm-12 col-md-7 col-lg-7 col-xl-7">
                <div class="row">
                    <div class="col-12">
                        <h4><a class="text-dark" href="{{publication.get_absolute_url}}">{{ publication.product_name }}</a></h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <h6><em>{{ publication.slug }}</em></h6>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <p class="lead">{{ publication.product_description }}</p>
                    </div>
                </div>
            </div>
            <div class="col-12 col-sm-12 col-md-3 col-lg-3 col-xl-3">
                <div class="row mt-5">
                    <div class="col-12">
                        <h4 class="text-warning text-right"><strong>$ {{ publication.price }}</strong></h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <p class="text-right">{{ publication.publication_date }}</p>
                    </div>
                </div>
            </div>
            <hr />
        </div>
        {% endfor %}
        {% else %}
        <div class="card-body text-center">
            <p class="lead">Este usuario no cuenta con ninguna publicación :(</p>
        </div>
        {% endif %}
    </div>

    <div class="container">
        <hr />
    </div>

    <div class="container mt-2">
        <h1 class="display-5">Comentarios</h1>
        <div class="row ml-3">
            {% if comments %}
            <div class="container">
                <div class="row">
                    <div class="col-12 text-center">
                        <button type="button" class="btn btn-lg btn-warning mb-2 " data-toggle="modal" data-target="#commentModal">Comenta ahora!</button>
                    </div>
                </div>
            </div>
            {% for comment in comments %}
            <div class="container">
                <div class="media">
                    {% if comment.sender.profile_picture%}
                    <a href="{{comment.sender.get_absolute_url}}"><img class="mr-3 rounded-circle" style="min-width:75px;min-height:75px;max-height:75px;max-width:75px;" src="{{comment.sender.profile_picture.url}}" style="max-width:4em;"></a>
                    {% else %}
                    <img class="mr-3 rounded-circle" style="min-width:75px;min-height:75px;max-height:75px;max-width:75px;" src="{% static 'users/img/profile-placeholder.gif' %}" style="max-width:4em;">
                    {% endif %}
                    <div class="media-body">
                        <h4 class="mt-0"><a class="text-dark" href="{{comment.sender.get_absolute_url}}">{{comment.sender.username}}</a></h4>
                        <div class="row">   
                            <div class="col-12">
                                <p class="lead" style="overflow-wrap: anywhere;">{{comment.message}}</p>
                            </div>
                        </div>
                        <p>{{comment.emission_date}}</p>
                    </div>   
                </div>
                <hr/>
            </div>
            {% endfor %}
            {% else %}
            <div class="card-body text-center">
                <p class="lead">Este usuario no tiene ningun comentario.</p>
                <button type="button" class="btn btn-warning" data-toggle="modal" data-target="#commentModal">Comenta
                    ahora!</button>
            </div>
            {% endif %}
        </div>
    </div>
</div>

<div class="modal fade" id="commentModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title text-center" id="exampleModalLabel">Comenta</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form method="POST" action="{% url 'comment-profile' profile_pk=user.id%}">
                <div class="modal-body">
                    {% csrf_token %}
                    <div class="row">
                        <div class="col-12">
                            {{comment_form.message|as_crispy_field}}
                            {{comment_form.sender|as_crispy_field}}
                            {{comment_form.recipient|as_crispy_field}}
                        </div>
                    </div>                    
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-dark" data-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-warning">Comentar</button>
                </div>
            </form>
        </div>
    </div>
</div>

<div class="modal fade" id="gradeModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Califica</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form method="POST" action="{% url 'rate-profile' %}">
                <div class="modal-body">
                {% csrf_token %}
                    {{rating_form.grader|as_crispy_field}}
                    {{rating_form.reciever|as_crispy_field}}
                    {{rating_form.grade|as_crispy_field}}
                    <div class="slidecontainer">
                        <input type="range" min="0" max="10" value="5" step="1" class="slider" id="gradeControlRange">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-dark" data-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-warning">Calificar</button>
                </div>
            </form>
        </div>
    </div>
</div>

<div class="modal fade" id="reportModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Reporte</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form method="POST" action="{% url 'report-profile' profile_pk=user.id%}">
                <div class="modal-body">
                {% csrf_token %}
                    {{report_form.sender|as_crispy_field}}
                    {{report_form.recipient|as_crispy_field}}
                    {{report_form.slug|as_crispy_field}}
                    {{report_form.message|as_crispy_field}}
                    {{report_form.category|as_crispy_field}}
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-dark" data-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-danger">Reportar</button>
                </div>
            </form>
        </div>
    </div>
</div>

<div class="modal fade" id="suggestionModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
    aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLabel">Sugerencia</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form method="POST" action="{% url 'suggest-profile' profile_pk=user.id%}">
                <div class="modal-body">
                {% csrf_token %}
                    {{suggestion_form.sender|as_crispy_field}}
                    {{suggestion_form.recipient|as_crispy_field}}
                    {{suggestion_form.slug|as_crispy_field}}
                    {{suggestion_form.message|as_crispy_field}}
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-dark" data-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-warning">Sugerir</button>
                </div>
            </form>
        </div>
    </div>
</div>

{% endblock %}

{% block scriptfiles %}
<script src="{% static 'users/js/userprofile.js' %}"></script>
{% endblock %}